module test1 (clk,r,g,b,hs,vs,vgaclk,       // vga interface
             addr,datain,dataout,wr,ready,      // cpu interface
             sram_addr,sram_ce_n,sram_dq,sram_lb_n,sram_oe_n,sram_ub_n,sram_we_n);// sram interface); 
				 // 1440x900 160x50 char with border text mode vga driver for DE2-115

// ver 0.15 alpha --- 2014.09.03
// (c) Piotr Kardasz pik33@we.pb.edu.pl
// This is free software, license: LGPL v.2.0 or newer

output reg [7:0] r,g,b;
output reg hs,vs;
output wire vgaclk; 
input wire clk;  //input clock=2x vgaclk
output wire ready;

reg [3:0] e;
reg f,mclk,oldwr,oldwr2;
reg [7:0] char2,char,attr,attr2,ramdata,ramdata2,brr,brb,brg,cposx,cposy;
reg [19:0] caddr,caddr2,cpos;
reg [9:0] lcnt;
reg [0:2] lstate,pstate; // 00 vis, 01 fp, 10 sync, 11 bp 100 border
reg [10:0] bb,c,d,ramaddr,pcnt;
reg [31:0] fcnt; //frame counter
reg [15:0] start;

input wire [20:0] addr;
input wire [15:0] datain;
output reg [15:0] dataout;
input wire wr;
output reg [19:0] sram_addr;
inout wire [15:0] sram_dq;
output reg sram_ce_n;
output reg sram_lb_n;
output reg sram_oe_n;
output reg sram_ub_n;
output reg sram_we_n;
reg [15:0] sramdqout,datain2,datain3;
reg [20:0] addr2;
reg fl,fl2;
reg[2:0] pcnt_mod;
reg[7:0] pcnt_char;
reg[15:0] pixels, pixels2;
reg mode;

(* ramstyle = "M9K" *) reg [7:0] fontdef[2048];  // character generator
reg[15:0] regs [64]; // internal registers


initial
  begin
  $readmemh("st4font.hex",fontdef);
  start<=20'b0000_0000_0000_0000_0000;
  fl<=0;
  fl2<=0;
  end
  
assign sram_dq = (sram_we_n==0) ? sramdqout : 16'bz;
assign ready=~fl;
assign vgaclk=clk;

always
  begin
  sram_lb_n=0;
  sram_ub_n=0;
  sram_ce_n=0;
  sram_oe_n=0;
  end

  
 
  
  
  
always@(posedge clk)

begin
pcnt_mod<=pcnt_mod+1;	 



      case (pcnt_mod)
		
		7:
		 begin
		 pixels2<=sram_dq; 
       end
		 
		0:begin
 		 if (wr==1) // do a write cycle
		   if (addr[20]==0)
	        begin  
	        sramdqout<=datain2;
	        sram_addr<=addr[19:0];
			  sram_we_n<=0; 
			  end
			else 
			  regs[addr[5:0]]<=datain2;
		  else
		    begin
		    sram_addr<=addr[19:0];
  		    sram_we_n<=1;
			 end
        end
	 
		 
    	4:
		   begin
			sram_we_n<=1;
			if (sram_we_n==1) if (addr[20]==0) dataout<=sram_dq; else dataout<=regs[addr[5:0]];
			sram_addr<=caddr; 
		  end
	

 
	
	
		  
      endcase 
		  
		end  
		  
  
endmodule 